DEFINE VARIABLE ghDocument AS HANDLE NO-UNDO.
DEFINE VARIABLE ghRoot AS HANDLE NO-UNDO.
DEFINE VARIABLE ghRow AS HANDLE NO-UNDO.
DEFINE VARIABLE ghField AS HANDLE NO-UNDO.
DEFINE VARIABLE ghText AS HANDLE NO-UNDO.

PROCEDURE create-objects.
    CREATE X-DOCUMENT ghDocument.
    CREATE X-NODEREF ghRoot.
    CREATE X-NODEREF ghRow.
    CREATE X-NODEREF ghField.
    CREATE X-NODEREF ghText.
END PROCEDURE.

PROCEDURE add-table.
    DEF INPUT PARAMETER i-table-name AS CHAR NO-UNDO.
    ghDocument:CREATE-NODE(ghRoot, i-table-name, "ELEMENT":U).
    ghDocument:APPEND-CHILD(ghRoot).
END PROCEDURE.

PROCEDURE add-row.
    DEF INPUT PARAMETER i-row-name AS CHAR NO-UNDO.
    ghDocument:CREATE-NODE(ghRow, i-row-name, "ELEMENT":U).
    ghRoot:APPEND-CHILD(ghRow).
END PROCEDURE.

function get-row-handle returns handle:
    return ghRow.
end function.

PROCEDURE add-field.
    DEF INPUT PARAMETER i-element-name AS CHAR NO-UNDO.
    DEF INPUT PARAMETER i-element-value AS CHAR NO-UNDO.
    
    if i-element-value = ? then i-element-value = "".

    ghDocument:CREATE-NODE(ghField, i-element-name, "ELEMENT":U).
    ghRow:APPEND-CHILD(ghField).

    ghDocument:CREATE-NODE(ghText, "", "TEXT":U).
    ghField:APPEND-CHILD(ghText).

    ghText:NODE-VALUE = i-element-value.

END PROCEDURE.

PROCEDURE add-data.
    DEF INPUT PARAMETER i-element-value AS CHAR NO-UNDO.

    ghDocument:CREATE-NODE(ghText, "", "TEXT":U).
    ghRow:APPEND-CHILD(ghText).

    ghText:NODE-VALUE = i-element-value.

END PROCEDURE.

function create-note returns handle
    (input i-element-name AS char):
    
    ghDocument:CREATE-NODE(ghField, i-element-name, "ELEMENT":U).
    
    return ghField.

end function.

PROCEDURE set-note-attr.
    DEF INPUT PARAMETER h-note AS handle NO-UNDO.
    DEF INPUT PARAMETER i-element-name AS CHAR NO-UNDO.
    DEF INPUT PARAMETER c-element-value AS CHAR NO-UNDO.
    
    if not valid-handle(h-note) then return.
    if c-element-value = ? then c-element-value = "".
    
    h-note:SET-ATTRIBUTE(i-element-name,c-element-value).
END PROCEDURE.

PROCEDURE set-note-value.
    DEF INPUT PARAMETER h-note AS handle NO-UNDO.
    DEF INPUT PARAMETER c-element-value AS CHAR NO-UNDO.
    
    if not valid-handle(h-note) then return.
    if c-element-value = ? then c-element-value = "".
    
    ghDocument:CREATE-NODE(ghText, "", "TEXT":U).
    h-note:APPEND-CHILD(ghText).

    ghText:NODE-VALUE = c-element-value.

END PROCEDURE.

PROCEDURE add-note.
    DEF INPUT PARAMETER h-note AS handle NO-UNDO.
    if not valid-handle(h-note) then return.
    ghRow:APPEND-CHILD(h-note).
END PROCEDURE.

PROCEDURE save-table.
    DEF INPUT PARAMETER i-fnimi AS CHAR NO-UNDO.
    ghDocument:SAVE("FILE":U, i-fnimi).
END PROCEDURE.

PROCEDURE delete-objects.
    DELETE OBJECT ghText.
    DELETE OBJECT ghField.
    DELETE OBJECT ghRow.
    DELETE OBJECT ghRoot.
    DELETE OBJECT ghDocument.
END.
